/* Generated test code to dump a table of data for external validation
 * of the noise model parameters.
 */
#include <stdio.h>
#include <assert.h>
double compute_noise_model_entry_S(int plane, int sens);
double compute_noise_model_entry_O(int plane, int sens);
int main(void) {
    for (int plane = 0; plane < 4; plane++) {
        for (int sens = 50; sens <= 600; sens += 100) {
            double o = compute_noise_model_entry_O(plane, sens);
            double s = compute_noise_model_entry_S(plane, sens);
            printf("%d,%d,%lf,%lf\n", plane, sens, o, s);
        }
    }
    return 0;
}

/* Generated functions to map a given sensitivity to the O and S noise
 * model parameters in the DNG noise model. The planes are in
 * R, Gr, Gb, B order.
 */
double compute_noise_model_entry_S(int plane, int sens) {
    static double noise_model_A[] = { 7.237017846089512e-06,6.523188249675823e-06,6.869138041655443e-06,7.91361915842508e-06 };
    static double noise_model_B[] = { -0.00011073147252834658,-4.891687244712177e-05,-7.575439118199129e-05,-0.00012886838607408598 };
    double A = noise_model_A[plane];
    double B = noise_model_B[plane];
    double s = A * sens + B;
    return s < 0.0 ? 0.0 : s;
}

double compute_noise_model_entry_O(int plane, int sens) {
    static double noise_model_C[] = { 4.391126846089045e-11,6.510038341056177e-11,8.252455519614475e-11,4.975852341921813e-11 };
    static double noise_model_D[] = { 2.526192822099787e-06,2.2153976695516784e-06,2.729145991526126e-06,2.637896049180895e-06 };
    double digital_gain = (sens / 600.0) < 1.0 ? 1.0 : (sens / 600.0);
    double C = noise_model_C[plane];
    double D = noise_model_D[plane];
    double o = C * sens * sens + D * digital_gain * digital_gain;
    return o < 0.0 ? 0.0 : o;
}
